# coding: utf-8

"""
    cloudglue API

    API for cloudglue

    The version of the OpenAPI document: 0.0.9
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cloudglue.sdk.models.extract_data_segment_entities_inner import ExtractDataSegmentEntitiesInner
from cloudglue.sdk.models.file_entities_entities import FileEntitiesEntities
from typing import Optional, Set
from typing_extensions import Self

class FileEntities(BaseModel):
    """
    FileEntities
    """ # noqa: E501
    collection_id: StrictStr = Field(description="ID of the collection")
    file_id: StrictStr = Field(description="ID of the file")
    entities: FileEntitiesEntities
    segment_entities: Optional[List[ExtractDataSegmentEntitiesInner]] = Field(default=None, description="Array of video entities extracted from individual time segments")
    total: StrictInt = Field(description="Total number of segments with extracted entities")
    limit: StrictInt = Field(description="Number of segments returned in this response (for segment entities)")
    offset: StrictInt = Field(description="Offset from the start of the list (for segment entities)")
    __properties: ClassVar[List[str]] = ["collection_id", "file_id", "entities", "segment_entities", "total", "limit", "offset"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FileEntities from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of entities
        if self.entities:
            _dict['entities'] = self.entities.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in segment_entities (list)
        _items = []
        if self.segment_entities:
            for _item_segment_entities in self.segment_entities:
                if _item_segment_entities:
                    _items.append(_item_segment_entities.to_dict())
            _dict['segment_entities'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FileEntities from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "collection_id": obj.get("collection_id"),
            "file_id": obj.get("file_id"),
            "entities": FileEntitiesEntities.from_dict(obj["entities"]) if obj.get("entities") is not None else None,
            "segment_entities": [ExtractDataSegmentEntitiesInner.from_dict(_item) for _item in obj["segment_entities"]] if obj.get("segment_entities") is not None else None,
            "total": obj.get("total"),
            "limit": obj.get("limit"),
            "offset": obj.get("offset")
        })
        return _obj


